require "Polycode/SceneEntity"

class "SceneMesh" (SceneEntity)



function SceneMesh:__index__(name)
	if name == "lightmapIndex" then
		return Polycore.SceneMesh_get_lightmapIndex(self.__ptr)
	elseif name == "showVertexNormals" then
		return Polycore.SceneMesh_get_showVertexNormals(self.__ptr)
	elseif name == "lineWidth" then
		return Polycore.SceneMesh_get_lineWidth(self.__ptr)
	elseif name == "lineSmooth" then
		return Polycore.SceneMesh_get_lineSmooth(self.__ptr)
	elseif name == "ownsMesh" then
		return Polycore.SceneMesh_get_ownsMesh(self.__ptr)
	elseif name == "ownsSkeleton" then
		return Polycore.SceneMesh_get_ownsSkeleton(self.__ptr)
	elseif name == "ownsTexture" then
		return Polycore.SceneMesh_get_ownsTexture(self.__ptr)
	end
end


function SceneMesh:__set_callback(name,value)
	if name == "lightmapIndex" then
		Polycore.SceneMesh_set_lightmapIndex(self.__ptr, value)
		return true
	elseif name == "showVertexNormals" then
		Polycore.SceneMesh_set_showVertexNormals(self.__ptr, value)
		return true
	elseif name == "lineWidth" then
		Polycore.SceneMesh_set_lineWidth(self.__ptr, value)
		return true
	elseif name == "lineSmooth" then
		Polycore.SceneMesh_set_lineSmooth(self.__ptr, value)
		return true
	elseif name == "ownsMesh" then
		Polycore.SceneMesh_set_ownsMesh(self.__ptr, value)
		return true
	elseif name == "ownsSkeleton" then
		Polycore.SceneMesh_set_ownsSkeleton(self.__ptr, value)
		return true
	elseif name == "ownsTexture" then
		Polycore.SceneMesh_set_ownsTexture(self.__ptr, value)
		return true
	end
	return false
end


function SceneMesh:SceneMesh(...)
	if type(arg[1]) == "table" and count(arg) == 1 then
		if ""..arg[1]:class() == "SceneEntity" then
			self.__ptr = arg[1].__ptr
			return
		end
	end
	for k,v in pairs(arg) do
		if type(v) == "table" then
			if v.__ptr ~= nil then
				arg[k] = v.__ptr
			end
		end
	end
	if self.__ptr == nil and arg[1] ~= "__skip_ptr__" then
		self.__ptr = Polycore.SceneMesh(unpack(arg))
		__ptr_lookup.SceneMesh[self.__ptr] = self
	end
end

function SceneMesh:Render()
	local retVal =  Polycore.SceneMesh_Render(self.__ptr)
end

function SceneMesh:getLocalShaderOptions()
	local retVal =  Polycore.SceneMesh_getLocalShaderOptions(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["ShaderBinding"][retVal] ~= nil then
		return __ptr_lookup["ShaderBinding"][retVal]
	else
		__ptr_lookup["ShaderBinding"][retVal] = _G["ShaderBinding"]("__skip_ptr__")
		__ptr_lookup["ShaderBinding"][retVal].__ptr = retVal
		return __ptr_lookup["ShaderBinding"][retVal]
	end
end

function SceneMesh:getMesh()
	local retVal =  Polycore.SceneMesh_getMesh(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["Mesh"][retVal] ~= nil then
		return __ptr_lookup["Mesh"][retVal]
	else
		__ptr_lookup["Mesh"][retVal] = _G["Mesh"]("__skip_ptr__")
		__ptr_lookup["Mesh"][retVal].__ptr = retVal
		return __ptr_lookup["Mesh"][retVal]
	end
end

function SceneMesh:getTexture()
	local retVal =  Polycore.SceneMesh_getTexture(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["Texture"][retVal] ~= nil then
		return __ptr_lookup["Texture"][retVal]
	else
		__ptr_lookup["Texture"][retVal] = _G["Texture"]("__skip_ptr__")
		__ptr_lookup["Texture"][retVal].__ptr = retVal
		return __ptr_lookup["Texture"][retVal]
	end
end

function SceneMesh:getMaterial()
	local retVal =  Polycore.SceneMesh_getMaterial(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["Material"][retVal] ~= nil then
		return __ptr_lookup["Material"][retVal]
	else
		__ptr_lookup["Material"][retVal] = _G["Material"]("__skip_ptr__")
		__ptr_lookup["Material"][retVal].__ptr = retVal
		return __ptr_lookup["Material"][retVal]
	end
end

function SceneMesh:loadTexture(fileName, clamp)
	local retVal = Polycore.SceneMesh_loadTexture(self.__ptr, fileName, clamp)
end

function SceneMesh:loadSkeleton(fileName)
	local retVal = Polycore.SceneMesh_loadSkeleton(self.__ptr, fileName)
end

function SceneMesh:setTexture(texture)
	local retVal = Polycore.SceneMesh_setTexture(self.__ptr, texture.__ptr)
end

function SceneMesh:setMaterial(material)
	local retVal = Polycore.SceneMesh_setMaterial(self.__ptr, material.__ptr)
end

function SceneMesh:setMaterialByName(materialName)
	local retVal = Polycore.SceneMesh_setMaterialByName(self.__ptr, materialName)
end

function SceneMesh:setMesh(mesh)
	local retVal = Polycore.SceneMesh_setMesh(self.__ptr, mesh.__ptr)
end

function SceneMesh:setSkeleton(skeleton)
	local retVal = Polycore.SceneMesh_setSkeleton(self.__ptr, skeleton.__ptr)
end

function SceneMesh:getSkeleton()
	local retVal =  Polycore.SceneMesh_getSkeleton(self.__ptr)
	if retVal == nil then return nil end
	if __ptr_lookup["Skeleton"][retVal] ~= nil then
		return __ptr_lookup["Skeleton"][retVal]
	else
		__ptr_lookup["Skeleton"][retVal] = _G["Skeleton"]("__skip_ptr__")
		__ptr_lookup["Skeleton"][retVal].__ptr = retVal
		return __ptr_lookup["Skeleton"][retVal]
	end
end

function SceneMesh:renderMeshLocally()
	local retVal =  Polycore.SceneMesh_renderMeshLocally(self.__ptr)
end

function SceneMesh:cacheToVertexBuffer(cache)
	local retVal = Polycore.SceneMesh_cacheToVertexBuffer(self.__ptr, cache)
end



if not __ptr_lookup then __ptr_lookup = {} end
__ptr_lookup.SceneMesh = {}

function SceneMesh:__delete()
	__ptr_lookup.SceneMesh[self.__ptr] = nil
	Polycore.delete_SceneMesh(self.__ptr)
end
