class "ShaderBinding"







function ShaderBinding:ShaderBinding(...)
	for k,v in pairs(arg) do
		if type(v) == "table" then
			if v.__ptr ~= nil then
				arg[k] = v.__ptr
			end
		end
	end
	if self.__ptr == nil and arg[1] ~= "__skip_ptr__" then
		self.__ptr = Polycore.ShaderBinding(unpack(arg))
		__ptr_lookup.ShaderBinding[self.__ptr] = self
	end
end

function ShaderBinding:clearTexture(name)
	local retVal = Polycore.ShaderBinding_clearTexture(self.__ptr, name)
end

function ShaderBinding:addTexture(name, texture)
	local retVal = Polycore.ShaderBinding_addTexture(self.__ptr, name, texture.__ptr)
end

function ShaderBinding:addParam(type, name, value)
	local retVal = Polycore.ShaderBinding_addParam(self.__ptr, type, name, value)
end

function ShaderBinding:addCubemap(name, cubemap)
	local retVal = Polycore.ShaderBinding_addCubemap(self.__ptr, name, cubemap.__ptr)
end

function ShaderBinding:getNumLocalParams()
	local retVal =  Polycore.ShaderBinding_getNumLocalParams(self.__ptr)
	return retVal
end

function ShaderBinding:getLocalParam(index)
	local retVal = Polycore.ShaderBinding_getLocalParam(self.__ptr, index)
	if retVal == nil then return nil end
	if __ptr_lookup["LocalShaderParam"][retVal] ~= nil then
		return __ptr_lookup["LocalShaderParam"][retVal]
	else
		__ptr_lookup["LocalShaderParam"][retVal] = _G["LocalShaderParam"]("__skip_ptr__")
		__ptr_lookup["LocalShaderParam"][retVal].__ptr = retVal
		return __ptr_lookup["LocalShaderParam"][retVal]
	end
end

function ShaderBinding:getLocalParamByName(name)
	local retVal = Polycore.ShaderBinding_getLocalParamByName(self.__ptr, name)
	if retVal == nil then return nil end
	if __ptr_lookup["LocalShaderParam"][retVal] ~= nil then
		return __ptr_lookup["LocalShaderParam"][retVal]
	else
		__ptr_lookup["LocalShaderParam"][retVal] = _G["LocalShaderParam"]("__skip_ptr__")
		__ptr_lookup["LocalShaderParam"][retVal].__ptr = retVal
		return __ptr_lookup["LocalShaderParam"][retVal]
	end
end

function ShaderBinding:addRenderTargetBinding(binding)
	local retVal = Polycore.ShaderBinding_addRenderTargetBinding(self.__ptr, binding.__ptr)
end

function ShaderBinding:getNumRenderTargetBindings()
	local retVal =  Polycore.ShaderBinding_getNumRenderTargetBindings(self.__ptr)
	return retVal
end

function ShaderBinding:getRenderTargetBinding(index)
	local retVal = Polycore.ShaderBinding_getRenderTargetBinding(self.__ptr, index)
	if retVal == nil then return nil end
	if __ptr_lookup["RenderTargetBinding"][retVal] ~= nil then
		return __ptr_lookup["RenderTargetBinding"][retVal]
	else
		__ptr_lookup["RenderTargetBinding"][retVal] = _G["RenderTargetBinding"]("__skip_ptr__")
		__ptr_lookup["RenderTargetBinding"][retVal].__ptr = retVal
		return __ptr_lookup["RenderTargetBinding"][retVal]
	end
end

function ShaderBinding:getNumInTargetBindings()
	local retVal =  Polycore.ShaderBinding_getNumInTargetBindings(self.__ptr)
	return retVal
end

function ShaderBinding:getInTargetBinding(index)
	local retVal = Polycore.ShaderBinding_getInTargetBinding(self.__ptr, index)
	if retVal == nil then return nil end
	if __ptr_lookup["RenderTargetBinding"][retVal] ~= nil then
		return __ptr_lookup["RenderTargetBinding"][retVal]
	else
		__ptr_lookup["RenderTargetBinding"][retVal] = _G["RenderTargetBinding"]("__skip_ptr__")
		__ptr_lookup["RenderTargetBinding"][retVal].__ptr = retVal
		return __ptr_lookup["RenderTargetBinding"][retVal]
	end
end

function ShaderBinding:getNumOutTargetBindings()
	local retVal =  Polycore.ShaderBinding_getNumOutTargetBindings(self.__ptr)
	return retVal
end

function ShaderBinding:getOutTargetBinding(index)
	local retVal = Polycore.ShaderBinding_getOutTargetBinding(self.__ptr, index)
	if retVal == nil then return nil end
	if __ptr_lookup["RenderTargetBinding"][retVal] ~= nil then
		return __ptr_lookup["RenderTargetBinding"][retVal]
	else
		__ptr_lookup["RenderTargetBinding"][retVal] = _G["RenderTargetBinding"]("__skip_ptr__")
		__ptr_lookup["RenderTargetBinding"][retVal].__ptr = retVal
		return __ptr_lookup["RenderTargetBinding"][retVal]
	end
end

function ShaderBinding:addLocalParam(name, ptr)
	local retVal = Polycore.ShaderBinding_addLocalParam(self.__ptr, name, ptr.__ptr)
end

function ShaderBinding:addLocalParamNumber(name, n)
	local retVal = Polycore.ShaderBinding_addLocalParamNumber(self.__ptr, name, n)
end

function ShaderBinding:addLocalParamVector3(name, v)
	local retVal = Polycore.ShaderBinding_addLocalParamVector3(self.__ptr, name, v.__ptr)
end



if not __ptr_lookup then __ptr_lookup = {} end
__ptr_lookup.ShaderBinding = {}

function ShaderBinding:__delete()
	__ptr_lookup.ShaderBinding[self.__ptr] = nil
	Polycore.delete_ShaderBinding(self.__ptr)
end
